=== debian/changelog ===
supernovas (1.5.0-1) unstable; urgency=medium

  * Removed legacy solsys1 / solsys2 sub-packages, no longer built upstream
  * Removed cio-data sub-packaged (no longer used, needed)
  * dev sub-package installes CMake / pkgconfig configurations
  * Switched to CMake for package build
  * Updated to upstream v1.5.0 -- feature release with fixes. 

 -- Attila Kovacs <attipaci@gmail.com>  Fri, 31 Oct 2025 11:54:58 +0100

supernovas (1.4.2-3) unstable; urgency=medium

  * Allow solsys1 / solsys2 sub-packages to work with future versions

 -- Attila Kovacs <attipaci@gmail.com>  Wed, 24 Sep 2025 17:42:15 +0200
