=== debian/control ===
Source: supernovas
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake, libcalceph-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
Homepage: https://smithsonian.github.io/SuperNOVAS
Rules-Requires-Root: no

Package: libsupernovas1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libsolsys-calceph1 (= ${binary:Version})
Description: SuperNOVAS C/C++ astrometry library
 SuperNOVAS is a C/C++ astronomy library, providing high-precision astronomical
 calculations such as one might need for running an observatory or a precise
 planetarium program. It is a fork of the Naval Observatory Vector Astrometry
 Software (NOVAS) C version 3.1, providing bug fixes and making it easier to
 use overall.
 .
 The main goals of SuperNOVAS are to improve usability, add new features,
 promote best practices, and provide accessible documentation -- all while
 retaining 100% API compatibility with NOVAS C 3.1. Thus, if you have written
 code for NOVAS C 3.1, you can build it with SuperNOVAS also.
 SuperNOVAS is entirely free to use without licensing restrictions. Its source
 code is compatible with the C90 standard, and hence should be suitable for old
 and new platforms alike. It is light-weight and easy to use, with full support
 for the IAU 2000/2006 standards for sub-micro-arc-second position.

Package: libsolsys-calceph1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libcalceph2
Description: Optional SuperNOVAS plugin library that provides Solar-system
 support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP
 2.0/3.0 data files with SuperNOVAS to obtain precise locations for
 Solar-system bodies. This plugin is currently the preferred option to use for
 Fedora / RPM Linux development, which requires use of precise Solar-system
 data.

Package: libsupernovas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libsolsys-calceph1 (= ${binary:Version})
Description: C development files for the SuperNOVAS C/C++ astronomy library
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the SuperNOVAS C/C++ library.

Package: libsupernovas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the SuperNOVAS C/C++ astronomy library
 This package provides man pages and HTML documentation for the SuperNOVAS
 C/C++ astronomy library.
