=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DBUILD_SHARED_LIBS=ON -DBUILD_TESTING=ON -DBUILD_DOC=ON -DENABLE_CALCEPH=ON

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md
