=== debian/tests/control ===
Tests: test-basic
Depends: @, build-essential, shunit2
Restrictions: allow-stderr

Tests: test-calceph
Depends: @, build-essential, libcalceph-dev, shunit2
Restrictions: allow-stderr
