## supernovas 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #
 
 
-cmake_minimum_required(VERSION 3.20)
+cmake_minimum_required(VERSION 3.24...4.2)
 
 # Project definition
 project(supernovas
@@ -71,9 +71,6 @@
 
 # Debug postfix for libraries
 set(CMAKE_DEBUG_POSTFIX d)
-
-# Position Independent Code for shared libs
-set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 
 # Build time locations for sub-configs
 link_directories(${CMAKE_BINARY_DIR}/lib)
@@ -167,10 +164,7 @@
 set_target_properties(core PROPERTIES
     VERSION ${PROJECT_VERSION}
     SOVERSION ${PROJECT_VERSION_MAJOR}
-    POSITION_INDEPENDENT_CODE ON
-    EXPORT_NAME supernovas
     OUTPUT_NAME supernovas
-    CLEAN_DIRECT_OUTPUT ON
 )
 
 target_include_directories(core PUBLIC
@@ -180,7 +174,7 @@
 
 # Link with math libs as necessary
 if(MATH_LIB)
-    target_link_libraries(core PRIVATE ${MATH})
+    target_link_libraries(core ${MATH})
 endif()
 
 # ----------------------------------------------------------------------------
@@ -196,7 +190,6 @@
     set_target_properties(${PLUGIN} PROPERTIES
         VERSION ${PROJECT_VERSION}
         SOVERSION ${PROJECT_VERSION_MAJOR}
-        POSITION_INDEPENDENT_CODE ON
     )
     
     if(CMAKE_USE_PTHREADS_INIT)
@@ -208,7 +201,7 @@
     
     find_library(EPHEM_LIBRARY ${EPHEM_LIB_NAME} REQUIRED)
     
-    target_link_libraries(solsys-${EPHEM_LIB_NAME} PRIVATE
+    target_link_libraries(solsys-${EPHEM_LIB_NAME}
         supernovas::core
         ${EPHEM_LIBRARY}
         ${MATH}
