=== debian/changelog ===
supernovas (1.5.1-2) unstable; urgency=medium

  * Back to version 4 for watch file (for now).

 -- Attila Kovacs <attipaci@gmail.com>  Sat, 03 Jan 2026 23:32:10 +0100

supernovas (1.5.1-1) unstable; urgency=medium

  * Updated to upstream v1.5.1 -- bug fix release (Closes: #1122486).
  * Updated standards to 4.7.3
  * Updated watch standards to 5
  * Follow lintian proposals

 -- Attila Kovacs <attipaci@gmail.com>  Fri, 02 Jan 2026 11:48:19 +0100
