=== debian/control ===
--- 
+++ 
@@ -5,11 +5,10 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13), cmake, libcalceph-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
 Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
 Homepage: https://smithsonian.github.io/SuperNOVAS
-Rules-Requires-Root: no
 
 Package: libsupernovas1
 Architecture: any
